<?php

include_once('Import/Seznamka.php');
include_once('Import/TanecniSkola.php');
include_once('Import/AstraPraha.php');
include_once('Import/Vavruska.php');
include_once('Import/SalsaDance.php');
include_once('Import/Amblar.php');
include_once('Import/MajkluvSvet.php');
include_once('Import/Csts.php');
include_once('Import/Facebook.php');
include_once('Import/Eso.php');

abstract class Gender
{
    const Undefined = 0;
    const Male = 1;
    const Female = 2;
}

function GetTextBetween(&$Text, $Start, $End)
{
  $Result = '';
  if ((strpos($Text, $Start) !== false) and (strpos($Text, $End) !== false))
  {
    $Text = substr($Text, strpos($Text, $Start) + strlen($Start));
    $Result = substr($Text, 0, strpos($Text, $End));
    $Text = substr($Text, strpos($Text, $End) + strlen($End));
  }
  return $Result;
}

function HumanDateTimeToTime($DateTime)
{
  if($DateTime == '') return(NULL);
  $DateTime = str_replace('. ', '.', $DateTime);
  $Parts = explode(' ', $DateTime);
  $DateParts = explode('.', $Parts[0]);
  if (count($Parts) > 1) $TimeParts = explode(':', $Parts[1]);
    else $TimeParts = array(0, 0, 0);
  $Result = mktime($TimeParts[0], $TimeParts[1], $TimeParts[2], $DateParts[1], $DateParts[0], $DateParts[2]);
  return($Result);
}

function HumanDateToTime($Date)
{
  if($Date == '') return(NULL);
  return(HumanDateTimeToTime($Date.' 0:0:0'));
}

function DecodeHtmlEnt($str)
{
  $prefix = '&#';
  $suffix = ';';
  $hexchar = 'x';
  $ret = html_entity_decode($str, ENT_COMPAT, 'UTF-8');
  $p2 = 0;
  for(;;)
  {
    $p = strpos($ret, $prefix, $p2);
    if ($p === FALSE)
      break;
    $p2 = strpos($ret, $suffix, $p);
    if ($p2 === FALSE)
    {
      $p2 = $p + strlen($prefix);
      while (($p2 < strlen($ret)) and is_numeric($ret[$p2]))
        $p2++;
      if ($p2 <= ($p + strlen($prefix))) break;
      $add = 0;
    } else $add = 1;

    if (substr($ret, $p + strlen($prefix), strlen($hexchar)) == $hexchar)
      $char = hexdec(substr($ret, $p + strlen($prefix) + strlen($hexchar), $p2 - $p - strlen($prefix) - strlen($hexchar)));
    else
      $char = intval(substr($ret, $p + strlen($prefix), $p2 - $p - strlen($prefix)));

    $newchar = iconv(
      'UCS-4', 'UTF-8',
      chr(($char >> 24) & 0xFF).chr(($char >> 16) & 0xFF).chr(($char >> 8) & 0xFF).chr($char & 0xFF)
    );
    $ret = substr_replace($ret, $newchar, $p, $add + $p2 - $p);
    $p2 = $p + strlen($newchar) + $add;
  }
  return $ret;
}

function RemoveHtmlComments($Content)
{
  $Result = '';
  while (strpos($Content, '<!--') !== false)
  {
    $Result .= substr($Content, 0, strpos($Content, '<!--'));
    $Content = substr($Content, strpos($Content, '<!--') + 4);
    $Content = substr($Content, strpos($Content, '-->') + 3);
  }
  return $Result;
  //return preg_replace('/<!--(.|\s)*?-->/', '', $Content);
}

function is_alpha($Char)
{
  return ((($Char >= 'a') and ($Char <= 'z')) or (($Char >= 'A') and ($Char <= 'Z')));
}

function is_white_space($Char)
{
  return ($Char == ' ') or ($Char == "\t");
}

function GetNumberBeforeText($Text, $Needle)
{
  $Result = '';
  for(;;)
  {
    $Pos = strpos($Text, $Needle);
    if ($Pos !== false)
    {
      if ((($Pos + strlen($Needle)) < strlen($Text)) and (is_alpha($Text[$Pos + strlen($Needle)])))
      {
        $Text = substr($Text, $Pos + 1);
        continue;
      }
      $Result = substr($Text, 0, $Pos);
      $Text = substr($Text, $Pos + 1);
      $Start = $Pos - 1;
      while (($Start >= 0) and (is_numeric($Result[$Start]) or is_white_space($Result[$Start])))
        $Start--;
      $Start++;
      $Result = trim(substr($Result, $Start, $Pos - $Start));
      break;
    } else break;
  }
  return $Result;
}

function GetNumberAfterText($Text, $Needle)
{
  $Result = '';
  for(;;)
  {
    $Pos = strpos($Text, $Needle);
    if ($Pos !== false)
    {
      if ((($Pos - 1) >= 0) and (is_alpha($Text[$Pos - 1])))
      {
        $Text = substr($Text, $Pos + 1);
        continue;
      }
      $Result = substr($Text, $Pos + strlen($Needle));
      $Text = substr($Text, $Pos + 1);
      $End = 0;
      while (($End < strlen($Result)) and (is_numeric($Result[$End]) or is_white_space($Result[$End])))
        $End++;
      $End--;

      $Result = trim(substr($Result, 0, $End + 1));
      if (is_numeric($Result)) break;
    } else break;
  }
  return $Result;
}

function GetAgeFromText($Text)
{
  $Text = strtolower($Text);
  $Result = GetNumberBeforeText($Text, 'let');
  if ($Result == '') $Result = GetNumberBeforeText($Text, 'rokov');
  if ($Result == '') $Result = GetNumberBeforeText($Text, 'letou');
  if ($Result == '') $Result = GetNumberAfterText($Text, 'je mi');
  if ($Result == '') $Result = GetNumberAfterText($Text, 'jsem');
  if ($Result == '') $Result = GetNumberAfterText($Text, 'čerstvých');
  if ($Result == '') $Result = GetAgeHeightWeightFromText($Text)[0];
  if ($Result == '') {
    $Year = GetNumberAfterText($Text, 'ročník');
    if ($Year != '') $Result = date('Y', time()) - $Year;
  }
  return $Result;
}

function GetHeightFromText($Text)
{
  $Text = strtolower($Text);
  $Result = GetNumberBeforeText($Text, 'cm');
  if ($Result == '') $Result = GetNumberAfterText($Text, 'měřím');
  if ($Result == '') $Result = GetNumberAfterText($Text, 'merim');
  if ($Result == '') $Result = GetNumberBeforeText($Text, 'bez podpatků');
  if ($Result == '') $Result = GetAgeHeightWeightFromText($Text)[1];
  return $Result;
}

function GetWeightFromText($Text)
{
  $Text = strtolower($Text);
  $Result = GetNumberBeforeText($Text, 'kg');
  if ($Result == '') $Result = GetNumberAfterText($Text, 'vážím');
  if ($Result == '') $Result = GetAgeHeightWeightFromText($Text)[2];
  return $Result;
}

function GetAgeHeightWeightFromText($Text)
{
  $Result = array('', '', '');
  $Pattern = '/[0-9]+\/[0-9]+\/[0-9]+/i';
  if (preg_match_all($Pattern, $Text, $Matches))
  {
    $Result = explode('/', $Matches[0][0]);
    // Avoid dates in a form day/month/year
    if ($Result[2] > 150) $Result = array('', '', '');
  } else
  {
    $Pattern = '/[0-9]+\/[0-9]+/i';
    if (preg_match_all($Pattern, $Text, $Matches))
    {
      $Result = explode('/', $Matches[0][0]);
      // If first number is over 100 then its probably height/weight
      if ($Result[0] > 100) $Result = array('', $Result[0], $Result[1]);
      $Result[] = '';
    }
  }
  return $Result;
}

function GetEmailFromText($Text)
{
  $Result = '';
  if (strpos($Text, '@') !== false)
  {
    $Pattern = '/[a-z0-9_\-\+\.]+@[a-z0-9\-]+\.([a-z]{2,4})(?:\.[a-z]{2})?/i';
    preg_match_all($Pattern, $Text, $Matches);
    if (count($Matches) > 0)
      $Result = $Matches[0][0];
  }
  return $Result;
}

$Locations = array(
  'praha' => 'Praha',
  'prahy' => 'Praha',
  'praze' => 'Praha',
  'brno' => 'Brno',
  'brně' => 'Brno',
  'ostrava' => 'Ostrava',
  'ostravě' => 'Ostrava',
  'ostravy' => 'Ostrava',
  'olomouc' => 'Olomouc',
  'liberec' => 'Liberec',
  'opava' => 'Opava',
  'opave' => 'Opava',
  'plzeň' => 'Plzeň',
  'plzni' => 'Plzeň',
  'vyškov' => 'Vyškov',
  'mladá boleslav' => 'Mladá Boleslav',
  'mladé boleslavi' => 'Mladá Boleslav',
  'litoměřice' => 'Litoměřice',
  'sokolov' => 'Sokolov',
  'mikulov' => 'Mikulov',
);

function GetLocationFromText($Text)
{
  global $Locations;
  
  $Text = strtolower($Text);

  foreach ($Locations as $Index => $Location)
  {
    if (strpos($Text, $Index) !== false) return $Location;
  }
  return '';
}

class MeetSources
{
  public $Database;

  function Parse($Id = null)
  {
    if (($Id != null) and is_numeric($Id)) $Where = 'Id='.$Id;
      else $Where = '1';
    $DbResult = $this->Database->select('MeetSource', '*', $Where);
    while ($DbRow = $DbResult->fetch_assoc())
    {
      $Method = $DbRow['Method'];
      if ($Method == 'hes') $Source = new MeetSourceTanecniSkola();
      else if ($Method == 'vavruska') $Source = new MeetSourceVavruska();
      else if ($Method == 'salsadance') $Source = new MeetSourceSalsaDance();
      else if ($Method == 'astra') $Source = new MeetSourceAstraPraha();
      else if ($Method == 'seznamka') $Source = new MeetSourceSeznamka();
      else if ($Method == 'amblar') $Source = new MeetSourceAmblar();
      else if ($Method == 'majkluvsvet') $Source = new MeetSourceMajkluvSvet();
      else if ($Method == 'csts') $Source = new MeetSourceCsts();
      else if ($Method == 'facebook') $Source = new MeetSourceFacebook();
      else if ($Method == 'eso') $Source = new MeetSourceEso();
      else {
        echo('Unsupported parse method: '.$Method.'<br/>');
        continue;
      }
      $Source->Database = $this->Database;
      $Source->Id = $DbRow['Id'];
      $Source->URL = $DbRow['URL'];
      $Source->Method = $Method;
      $Source->Name = $DbRow['Name'];
      $this->Items[] = $Source;
      $Source->Import();
    }
  }
}

class MeetSource
{
  public $Name;
  public $URL;
  public $Method;
  public $Id;
  public $Database;

  function Import()
  {
    $this->AddedCount = 0;
    echo('Parsing '.$this->Name.' ('.$this->Id.')...</br>');
  }
}

class MeetItem
{
  var $Database;
  var $Name = '';
  var $Message = '';
  var $Date = '';
  var $Gender = Gender::Undefined;
  var $Phone = '';
  var $Email = '';
  var $Age = '';
  var $Height = '';
  var $Source = 0;
  var $Weight = '';
  var $Location = '';
  var $Image = '';
  var $Link = '';
  var $Title = '';
  var $Level = '';

  function AddIfNotExist()
  {
    $DbResult = $this->Database->select('MeetItem', '*',
      '(`Message` = "'.$this->Database->real_escape_string($this->Message).'") AND '.
      '(`Email` = "'.$this->Database->real_escape_string($this->Email).'") AND '.
      '(`Date` = "'.$this->Database->real_escape_string(TimeToMysqlDate($this->Date)).'")');
    if ($DbResult->num_rows == 0)
    {
      $this->Database->insert('MeetItem', array(
        'Message' => $this->Message,
        'Date' => TimeToMysqlDate($this->Date),
        'Gender' => $this->Gender,
        'Age' => $this->Age,
        'Email' => $this->Email,
        'Phone' => $this->Phone,
        'Name' => $this->Name,
        'Height' => $this->Height,
        'Weight' => $this->Weight,
        'Location' => $this->Location,
        'Source' => $this->Source,
        'Link' => $this->Link,
      ));
      $Result = 1;
    } else $Result = 0;
    return($Result);
  }
}
